#!/usr/bin/env python
# *-* coding:utf-8 *-*

##
## Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
##
## This software is published by the license of CPU-OS License, you can use and
## distibuted this software under this License. See CPU-OS Liense for more detail.
##
## You should have receive a copy of CPU-OS License. If not, please contact us
## by email <support_os@cpu-os.ac.cn>
##
##

import os
import urllib
import gtk
from subprocess import Popen, PIPE
import os, sys, apt, tempfile, gettext
from subprocess import Popen, PIPE
try:
    import pygtk
    pygtk.require("2.0")
except Exception, detail:
    print detail
    pass

import threading
SERVER_IP = "172.29.16.10"

origin_manifest = {}
new_manifest = {}
cur_manifest = {}
is_updateing = False

def networkBroken():
    print "network is broken"
    sys.exit(1)

class CheckUpdateThread(threading.Thread):


    def __init__(self):
            threading.Thread.__init__(self)

    def run(self):
        # gtk.gdk.threads_enter()
        if self.check_user_choose():
            if self.show_third_party_package():
                self.update_system()

    def update_system(self):
        global is_updateing
        # Turn off the screensaver during the upgrade
        screensaver_setting = None
        screensaver_enabled = "true"

        screensaver_setting = "org.cinnamon.desktop.screensaver lock-enabled"
        if screensaver_setting is not None:
            enabled = os.popen("gsettings get %s" % screensaver_setting).readlines()[0].strip()
            if enabled == "false":
                screensaver_enabled = "false"
            else:
                os.system("gsettings set %s false" % screensaver_setting)
        new_repository_list_path = os.path.join(os.getenv("HOME"), ".config/linuxmint/official-package-repositories.list")
        #cmd = ["/usr/bin/cdos-release-upgrade-root", "%s" % new_repository_list_path, "%s" % self.dialog.window.xid]
        local_path = os.getenv("HOME")
        backup_flag = self.show_backup_tip()
        print "backup_flag : %s" %backup_flag
        cmd = ["/usr/bin/cdos-release-upgrade-root", "%s" % new_repository_list_path, "%s" % local_path, "%s" % backup_flag]
        comnd = Popen(' '.join(cmd), shell=True)
        returnCode = comnd.wait()
        print "update_system"
        print returnCode
        with open ("/etc/lsb-release") as f:
            for line in f.readlines():
                if line.startswith("DISTRIB_RELEASE"):
                    cur_release = line.split("=")[-1].strip("\n")
        with open (os.path.join(os.getenv("HOME"), ".config/linuxmint/current.manifest")) as f:
            for line in f.readlines():
                if line.startswith("DISTRIB_RELEASE"):
                    old_release = line.split("=")[-1].strip("\n")

        is_updateing = False
        print is_updateing
        # Reset the screensaver the way it was before the upgrade
        if screensaver_setting is not None:
            os.system("gsettings set %s %s" % (screensaver_setting, screensaver_enabled))

    def show_backup_tip(self):
        backup_flag = False
        gtk.gdk.threads_enter()
        dialog = gtk.MessageDialog(None, gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT, gtk.MESSAGE_QUESTION)
        dialog.set_title("系统更新")
        #dialog.segtk.gdk.threads_enter()t_icon_from_file("/usr/lib/linuxmint/mintUpdate/icons/base.svg")
        dialog.set_markup("为防止升级失败导致数据丢失，可以在更新前备份系统，备份系统预计要十分钟，是否备份？")
        dialog.add_buttons("备份",gtk.RESPONSE_ACCEPT)
        dialog.add_buttons("不备份",gtk.RESPONSE_CANCEL)
        dialog.set_position(gtk.WIN_POS_CENTER)
        dialog.set_default_size(320, 200)
        dialog.set_resizable(True)
        dialog.show_all()
        r=dialog.run()
        if r == gtk.RESPONSE_CANCEL or r == gtk.RESPONSE_DELETE_EVENT:
            print "cancel c不备份e"
            dialog.hide()
            dialog.destroy()
            is_updateing=False
            gtk.gdk.threads_leave()
        else:
            print "进行备份"
            dialog.hide()
            dialog.destroy()
            gtk.gdk.threads_leave()
            backup_flag = True
        return backup_flag

    def show_third_party_package(self):
        global is_updateing
        gtk.gdk.threads_enter()
        self.dialog = gtk.MessageDialog(None, gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT, gtk.MESSAGE_QUESTION)
        self.dialog.set_title("软件包更新")
        self.dialog.set_markup("如下软件包是第三方软件包，更新可能会导致不可用，是否更新？")
        scrolledWindow = gtk.ScrolledWindow()
        scrolledWindow.set_shadow_type(gtk.SHADOW_IN)
        scrolledWindow.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        treeview = gtk.TreeView()
        column1 = gtk.TreeViewColumn("", gtk.CellRendererText(), text=0)
        column1.set_sort_column_id(0)
        column1.set_resizable(True)
        treeview.append_column(column1)
        treeview.set_headers_clickable(False)
        treeview.set_reorderable(False)
        treeview.set_headers_visible(False)
        model = gtk.TreeStore(str)
        #获得更新包，用户自定义安装包，以及待删除的包
        custom_pkgs, new_pkgs, nhold_pkgs = self.get_update_pkgs()
        local_config_path =os.path.join(os.getenv("HOME"), ".config/linuxmint/")
        with open(os.path.join(local_config_path, "new_pkgs"), "w") as f:
            f.write('\n'.join(new_pkgs))
        custom_pkgs = list(custom_pkgs)
        custom_pkgs.sort()
        for pkg in custom_pkgs:
            iter = model.insert_before(None, None)
            model.set_value(iter, 0, pkg)
        treeview.set_model(model)
        treeview.show()
        scrolledWindow.add(treeview)
        self.dialog.vbox.add(scrolledWindow)
        self.dialog.add_buttons("确定更新",gtk.RESPONSE_ACCEPT)
        self.dialog.add_buttons("取消",gtk.RESPONSE_CANCEL)
        self.dialog.set_position(gtk.WIN_POS_CENTER)
        self.dialog.set_default_size(640, 400)
        self.dialog.set_resizable(True)
        self.dialog.show_all()
        r=self.dialog.run()
        if r == gtk.RESPONSE_CANCEL or r == gtk.RESPONSE_DELETE_EVENT:
            print "cancel  show_third_party_package"
            self.dialog.hide()
            self.dialog.destroy()
            gtk.gdk.threads_leave()
            is_updateing=False
            return False
        else:
            print "open  show_third_party_package"
            self.dialog.hide()
            self.dialog.destroy()
            gtk.gdk.threads_leave()
            is_updateing=True
            return True


    def check_user_choose(self):
        self.flag = False
        global is_updateing
        if  is_updateing:
            print "hahahah"
            print is_updateing
        else:
            if  self.check_need_update():
                is_updateing=True
                gtk.gdk.threads_enter()
                dialog = gtk.MessageDialog(None, gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT, gtk.MESSAGE_QUESTION)
                dialog.set_title("系统升级")
                #dialog.set_icon_from_file("/usr/lib/linuxmint/mintUpdate/icons/base.svg")
                msg = "检测到系统有新版本,当前系统版本%s,\n最新版本%s，是否升级?"  %(self.cur_release, self.new_release)
                dialog.set_markup(msg)
                dialog.label.set_line_wrap(True)
                #checkbutton = gtk.CheckButton("以后不再提醒")
                #checkbutton.connect("toggled", self.checkbutton_toggled)
                #dialog.vbox.add(checkbutton)
                dialog.add_buttons("马上升级",gtk.RESPONSE_ACCEPT)
                dialog.add_buttons("下次升级",gtk.RESPONSE_CANCEL)
                dialog.set_position(gtk.WIN_POS_CENTER)
                dialog.set_default_size(320, 200)
                dialog.set_resizable(True)
                dialog.show_all()
                r=dialog.run()
                if r == gtk.RESPONSE_CANCEL or r == gtk.RESPONSE_DELETE_EVENT:
                    print "cancel check user choose"
                    dialog.destroy()
                    if self.flag:
                        is_updateing=True
                    else:
                        is_updateing=False
                    gtk.gdk.threads_leave()
                    return False
                else:
                    print "open check user choose"
                    dialog.destroy()
                    gtk.gdk.threads_leave()
                    return True


    def check_need_update(self):
        new_release_url = "http://%s/lsb-release" % SERVER_IP
        new_release = None
        try:
            r = urllib.urlopen(new_release_url)
            for line in r.readlines():
                if line.startswith("DISTRIB_RELEASE"):
                    new_release = line.split("=")[-1].strip("\n")
            r.close()

            cur_release = None
            with open ("/etc/lsb-release") as f:
                for line in f.readlines():
                    if line.startswith("DISTRIB_RELEASE"):
                        cur_release = line.split("=")[-1].strip("\n")
            self.cur_release = cur_release
            self.new_release = new_release
            print "check need_update"
            print self.new_release
            return new_release != cur_release
        except:
            networkBroken()


    def get_update_pkgs(self):
        server_path = "http://%s/" % SERVER_IP
        local_path =os.path.join(os.getenv("HOME"), ".config/linuxmint/")
        if not os.path.exists(local_path):
            os.makedirs(local_path,mode=0755)
        try:
            urllib.urlretrieve(server_path+"filesystem.manifest",local_path+"filesystem.manifest")
            urllib.urlretrieve(server_path+"official-package-repositories.list",local_path+"official-package-repositories.list")
            urllib.urlretrieve(server_path+"lsb-release",local_path+"lsb-release")
        except:
            networkBroken()
             

        origin_manifest_path = ("/etc/filesystem.manifest")
        with open(origin_manifest_path) as f:
            for line in f.readlines():
                (key, value) = line.strip("\n").split()
                origin_manifest[key] = value

        cur_manifest_path = os.path.join(os.getenv("HOME"), ".config/linuxmint/current.manifest")
        os.system("dpkg-query -W --showformat='${Package} ${Version}\n' > %s" % cur_manifest_path)
        with open(cur_manifest_path) as f:
            for line in f.readlines():
                (key, value) = line.strip("\n").split()
                cur_manifest[key] = value

        new_manifest_url = "http://%s/filesystem.manifest" % SERVER_IP
        try:
            f = urllib.urlopen(new_manifest_url)
            for line in f.readlines():
                (key, value) = line.strip("\n").split()
                new_manifest[key] = value
            f.close()
        except:
            networkBroken()

        custom_pkgs = set(cur_manifest.keys()) - set(origin_manifest.keys())
        new_pkgs = set(new_manifest.keys()) - set(origin_manifest.keys())
        nhold_pkgs = set(origin_manifest.keys()) - set(new_manifest.keys()) - custom_pkgs

        return (custom_pkgs, new_pkgs, nhold_pkgs)


    def checkbutton_toggled(self,*agrv):
        print "toggled confirm"
        if self.flag:
            self.flag = False
        else:
            self.flag = True
gtk.gdk.threads_init()
checkUpdateThread = CheckUpdateThread()
print "can run check update system"
checkUpdateThread.start()
gtk.main()