
##
## Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
##
## This software is published by the license of CPU-OS License, you can use and
## distibuted this software under this License. See CPU-OS Liense for more detail.
##
## You should have receive a copy of CPU-OS License. If not, please contact us
## by email <support_os@cpu-os.ac.cn>
##
##

from PyQt4.QtGui import *
from PyQt4.QtCore import *
import math, sys
import resource_rc

try:
    _fromUtf8 = QString.fromUtf8
except AttributeError:
    def _fromUtf8(s):
        return s

try:
    _encoding = QApplication.UnicodeUTF8
    def _translate(context, text, disambig):
        return QApplication.translate(context, text, disambig, _encoding)
except AttributeError:
    def _translate(context, text, disambig):
        return QApplication.translate(context, text, disambig)
    
    

class RotateWidget(QWidget):
    def __init__(self, parent=None):
        super(RotateWidget, self).__init__(parent)
        self.timerId = 0
        self.scroll = 0
        self.pixmap = QPixmap()
        self.pixmap.load(":/image/image/loading.png")
        self.setSizePolicy(QSizePolicy.Minimum, QSizePolicy.Minimum)
        self.setAutoFillBackground(True)
        palette = QPalette()
        palette.setColor(QPalette.Background, QColor(255,0,127))
        self.setPalette(palette)
        
        self.resize(self.sizeHint())
        self.setSizePolicy(QSizePolicy.Minimum, QSizePolicy.Minimum)
    
    def sizeHint(self):
        a = self.pixmap.width()
        b = self.pixmap.height()
        side = math.ceil(math.sqrt(a*a + b*b))
        return QSize(side, side)
    
    def paintEvent(self,event):
        painter = QPainter(self)
        size = self.pixmap.size()
        centerPoint = QPointF(self.width()/2.0, self.height()/2.0)
        painter.translate(centerPoint)
        painter.rotate(self.scroll)

        painter.translate(-size.width()/2.0, -size.height()/2.0)
        painter.drawPixmap(0, 0, size.width(), size.height(), self.pixmap)
        
        
    def showEvent(self,event):
        self.timerId = self.startTimer(50)
    
    def timerEvent(self,event):
        if self.timerId == event.timerId():
            self.scroll += 10
            if self.scroll == 360:
                self.scroll = 0            
            self.update()
        else:
            QWidget.timerEvent(self,event)
            
    def hideEvent(self, event):
        if not self.timerId:
            self.killTimer(self.timerId)
            self.timerId = 0
            self.scroll = 0
            
            
if __name__ == "__main__":
    app = QApplication(sys.argv)
    widget = QWidget()
    widget.resize(700,500)
    
    rotateWidget = RotateWidget(widget)
    rotateWidget.move(50,50)
    
    widget.show()
    app.exec_()